Understanding the devices.edgelq.com service APIv1, in proto package ntt.devices.v1.

Service devices.edgelq.com in version v1, proto package ntt.devices.v1

Here is the list of resources supported in Devices service APIv1:

CustomizedImage Resource

CustomizedImage Resource

Name patterns:

  • projects/{project}/regions/{region}/customizedImages/{customized_image}

Parent resources:

This section covers the methods and messages to interact with CustomizedImage resource.

CustomizedImage Methods

Here is the list of CustomizedImage resource methods:

GetCustomizedImage Method

GetCustomizedImage

rpc GetCustomizedImage(GetCustomizedImageRequest) returns (CustomizedImage)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/customizedImages.get

The equivalent REST API is:

GET /v1/{name=projects/*/regions/*/customizedImages/*} 

BatchGetCustomizedImages Method

BatchGetCustomizedImages

rpc BatchGetCustomizedImages(BatchGetCustomizedImagesRequest) returns (BatchGetCustomizedImagesResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/customizedImages.batchGet

The equivalent REST API is:

GET /v1/customizedImages:batchGet 

ListCustomizedImages Method

ListCustomizedImages

rpc ListCustomizedImages(ListCustomizedImagesRequest) returns (ListCustomizedImagesResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/customizedImages.list

The equivalent REST API is:

GET /v1/{parent=projects/*/regions/*}/customizedImages 

WatchCustomizedImage Method

WatchCustomizedImage

rpc WatchCustomizedImage(WatchCustomizedImageRequest) returns (WatchCustomizedImageResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/customizedImages.watch

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/customizedImages/*}:watch 

WatchCustomizedImages Method

WatchCustomizedImages

rpc WatchCustomizedImages(WatchCustomizedImagesRequest) returns (WatchCustomizedImagesResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/customizedImages.watch

The equivalent REST API is:

POST /v1/{parent=projects/*/regions/*}/customizedImages:watch 

CreateCustomizedImage Method

CreateCustomizedImage

rpc CreateCustomizedImage(CreateCustomizedImageRequest) returns (CustomizedImage)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/customizedImages.create

The equivalent REST API is:

POST /v1/{parent=projects/*/regions/*}/customizedImages (BODY: customized_image)

UpdateCustomizedImage Method

UpdateCustomizedImage

rpc UpdateCustomizedImage(UpdateCustomizedImageRequest) returns (CustomizedImage)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/customizedImages.update

The equivalent REST API is:

PUT /v1/{customized_image.name=projects/*/regions/*/customizedImages/*} (BODY: customized_image)

DeleteCustomizedImage Method

DeleteCustomizedImage

rpc DeleteCustomizedImage(DeleteCustomizedImageRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/customizedImages.delete

The equivalent REST API is:

DELETE /v1/{name=projects/*/regions/*/customizedImages/*} 

RequestUrl Method

RequestUrl

rpc RequestUrl(RequestUrlRequest) returns (RequestUrlResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/customizedImages.requestUrl

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/customizedImages/*}:requestUrl 

CustomizedImage Messages

Here is the list of CustomizedImage resource messages:

CustomizedImage Message

NameTypeDescription
namestring (name of CustomizedImage)Name of CustomizedImage When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
specCustomizedImage.Spec
statusCustomizedImage.Status

CustomizedImage.Spec Message

NameTypeDescription
versionstringDeprecated. Use os_version instead. After a while, version and device_type are removed and os_version becomes required
device_typestring
os_versionstring (reference to OsVersion)
provisioning_policystringEither provisioning_policy or service_account must be specified
service_accountstring (reference to ServiceAccount)
service_account_keystring (reference to ServiceAccountKey)
passwordstringPassword for ‘admin’ user in the image. Please generate it using bcrypt (e.g. mkpasswd --method=bcrypt) and provide the hashed value ref: https://www.usenix.org/legacy/event/usenix99/provos/provos.pdf
encryptionbool
encryption_passwordstringUnlike password field, encryption_password must be plain text This field will be set to "" after the image is ready
disk_mappingstring
network_agentstring
ntpstring
http_proxystring
https_proxystring
no_proxystring

CustomizedImage.Status Message

NameTypeDescription
stateCustomizedImage.Status.StateState of the image.
logstringError log when state is ERROR.
filestringTODO hide this from client
md5sumstringbase64 encoded

GetCustomizedImageRequest Message

A request message of the GetCustomizedImage method.

NameTypeDescription
namestring (name of CustomizedImage)Name of ntt.devices.v1.CustomizedImage
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetCustomizedImagesRequest Message

A request message of the BatchGetCustomizedImages method.

NameTypeDescription
namesrepeated string (name of CustomizedImage)Names of CustomizedImages
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetCustomizedImagesResponse Message

A response message of the BatchGetCustomizedImages method.

NameTypeDescription
customized_imagesrepeated CustomizedImagefound CustomizedImages
missingrepeated string (name of CustomizedImage)list of not found CustomizedImages

ListCustomizedImagesRequest Message

A request message of the ListCustomizedImages method.

NameTypeDescription
parentstring (parent name of CustomizedImage)Parent name of ntt.devices.v1.CustomizedImage
page_sizeint32Requested page size. Server may return fewer CustomizedImages than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of CustomizedImage)A token identifying a page of results the server should return. Typically, this is the value of ListCustomizedImagesResponse.next_page_token.
order_bystring (orderBy of CustomizedImage)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of CustomizedImage)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListCustomizedImagesResponse Message

A response message of the ListCustomizedImages method.

NameTypeDescription
customized_imagesrepeated CustomizedImageThe list of CustomizedImages
prev_page_tokenstring (cursor of CustomizedImage)A token to retrieve previous page of results. Pass this value in the ListCustomizedImagesRequest.page_token.
next_page_tokenstring (cursor of CustomizedImage)A token to retrieve next page of results. Pass this value in the ListCustomizedImagesRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total CustomizedImages across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchCustomizedImageRequest Message

A request message of the WatchCustomizedImage method.

NameTypeDescription
namestring (name of CustomizedImage)Name of ntt.devices.v1.CustomizedImage
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchCustomizedImageResponse Message

A response message of the WatchCustomizedImage method.

NameTypeDescription
changeCustomizedImageChange

WatchCustomizedImagesRequest Message

A request message of the WatchCustomizedImages method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of CustomizedImage)Parent name of ntt.devices.v1.CustomizedImage
page_sizeint32Requested page size. Server may return fewer CustomizedImages than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of CustomizedImage)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of CustomizedImage)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of CustomizedImage)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to CustomizedImage that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to CustomizedImage that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchCustomizedImagesResponse Message

A response message of the WatchCustomizedImages method.

NameTypeDescription
customized_image_changesrepeated CustomizedImageChangeChanges of CustomizedImages
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All CustomizedImages will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchCustomizedImagesResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (CustomizedImages will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchCustomizedImagesResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of CustomizedImage)New token to retrieve previous page of results.
next_page_tokenstring (cursor of CustomizedImage)New token to retrieve next page of results.

CreateCustomizedImageRequest Message

A request message of the CreateCustomizedImage method.

NameTypeDescription
parentstring (parent name of CustomizedImage)Parent name of ntt.devices.v1.CustomizedImage
customized_imageCustomizedImageCustomizedImage resource body
response_maskCreateCustomizedImageRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateCustomizedImageRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateCustomizedImageRequest Message

A request message of the UpdateCustomizedImage method.

NameTypeDescription
customized_imageCustomizedImageCustomizedImage resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateCustomizedImageRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateCustomizedImageRequest.ResponseMaskreduce message response size.

UpdateCustomizedImageRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateCustomizedImageConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateCustomizedImageRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteCustomizedImageRequest Message

A request message of the DeleteCustomizedImage method.

NameTypeDescription
namestring (name of CustomizedImage)Name of ntt.devices.v1.CustomizedImage
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

RequestUrlRequest Message

Request message for method [RequestUrl][ntt.devices.v1.RequestUrl]

NameTypeDescription
namestring (name of CustomizedImage)name of ntt.devices.v1.CustomizedImage

RequestUrlResponse Message

Response message for method [RequestUrl][ntt.devices.v1.RequestUrl]

NameTypeDescription
urlstring
headersrepeated string

CustomizedImage Enumerations

Here is the list of CustomizedImage resource enumerations:

CustomizedImage.Status.State Enumeration

NameDescription
STATE_UNSPECIFIEDInitial state
IN_PROGRESSBackend is processing the customization request.
ERRORThere was an error processing the customization request. Check the parameters and try again.
READYThe customized image is ready to download.

Device Resource

Device Resource

Name patterns:

  • projects/{project}/regions/{region}/devices/{device}

Parent resources:

This section covers the methods and messages to interact with Device resource.

Device Methods

Here is the list of Device resource methods:

GetDevice Method

GetDevice

rpc GetDevice(GetDeviceRequest) returns (Device)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.get

The equivalent REST API is:

GET /v1/{name=projects/*/regions/*/devices/*} 

BatchGetDevices Method

BatchGetDevices

rpc BatchGetDevices(BatchGetDevicesRequest) returns (BatchGetDevicesResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.batchGet

The equivalent REST API is:

GET /v1/devices:batchGet 

ListDevices Method

ListDevices

rpc ListDevices(ListDevicesRequest) returns (ListDevicesResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.list

The equivalent REST API is:

GET /v1/{parent=projects/*/regions/*}/devices 

WatchDevice Method

WatchDevice

rpc WatchDevice(WatchDeviceRequest) returns (WatchDeviceResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.watch

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/devices/*}:watch 

WatchDevices Method

WatchDevices

rpc WatchDevices(WatchDevicesRequest) returns (WatchDevicesResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.watch

The equivalent REST API is:

POST /v1/{parent=projects/*/regions/*}/devices:watch 

CreateDevice Method

CreateDevice

rpc CreateDevice(CreateDeviceRequest) returns (Device)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.create

The equivalent REST API is:

POST /v1/{parent=projects/*/regions/*}/devices (BODY: device)

UpdateDevice Method

UpdateDevice

rpc UpdateDevice(UpdateDeviceRequest) returns (Device)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.update

The equivalent REST API is:

PUT /v1/{device.name=projects/*/regions/*/devices/*} (BODY: device)

DeleteDevice Method

DeleteDevice

rpc DeleteDevice(DeleteDeviceRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.delete

The equivalent REST API is:

DELETE /v1/{name=projects/*/regions/*/devices/*} 

SearchDevices Method

SearchDevices

rpc SearchDevices(SearchDevicesRequest) returns (SearchDevicesResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.search

The equivalent REST API is:

GET /v1/{parent=projects/*/regions/*}/devices:search 

GetDedicatedEndpoints Method

GetDedicatedEndpoints

rpc GetDedicatedEndpoints(GetDedicatedEndpointsRequest) returns (GetDedicatedEndpointsResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.getDedicatedEndpoints

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/devices/*}:getDedicatedEndpoints 

ProvisionServiceAccountToDevice Method

ProvisionServiceAccountToDevice

rpc ProvisionServiceAccountToDevice(ProvisionServiceAccountToDeviceRequest) returns (ProvisionServiceAccountToDeviceResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.provisionServiceAccountToDevice

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/devices/*}:provisionServiceAccountToDevice 

RemoveServiceAccountFromDevice Method

RemoveServiceAccountFromDevice

rpc RemoveServiceAccountFromDevice(RemoveServiceAccountFromDeviceRequest) returns (RemoveServiceAccountFromDeviceResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.removeServiceAccountFromDevice

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/devices/*}:removeServiceAccountFromDevice 

Heartbeat Method

Heartbeat

rpc Heartbeat(HeartbeatMsg) returns (HeartbeatResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.heartbeat

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/devices/*}:heartbeat 

ReportDeviceMetrics Method

ReportDeviceMetrics

rpc ReportDeviceMetrics(ReportDeviceMetricsRequest) returns (ReportDeviceMetricsResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.reportDeviceMetrics

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/devices/*}:reportDeviceMetrics 

ListPublicDevices Method

ListPublicDevices

rpc ListPublicDevices(ListPublicDevicesRequest) returns (ListPublicDevicesResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/devices.listPublicDevices

The equivalent REST API is:

GET /v1/{parent=projects/*/regions/*}/devices:listPublicDevices 

Device Messages

Here is the list of Device resource messages:

Device Message

NameTypeDescription
namestring (name of Device)Name of Device When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
display_namestringDisplay name for the device
descriptionstringOptional. Description of the Device.
specDevice.SpecSpec holds the expected state of the Device, meaning configurations.
statusDevice.StatusStatus of the Device reported from the actual device.
public_listing_specDevice.PublicListingSpec

Device.Spec Message

NameTypeDescription
service_accountstring (reference to ServiceAccount)The associated service account to the Device. The agents in the device uses a key from this service account when they issue any requests to our endpoints for authoroization and authentication. ProvisionServiceAccountToDevice creates a new service account and a key for the Device and asign the account to this fileld. If you change the value of this field, the existing device would lose the access to the resources in our services, that means you can revoke the permissions from the device. You can manually set an empty value to do so, or call RemoveServiceAccountFromDevice.
log_bucketstring (reference to Bucket)Logging bucket associated with device
metrics_bucketstring (reference to Bucket)Monitoring metrics bucket associated with device
os_versionstringThe expected OS version in string (e.g. 1.0.2). The device will automatically download the OS image and upgrade itself with it. You can stack the OS upgrade progress in the Condition named OSReady in Status.Conditions.
netplan_yaml_configstring
netplan_api_config_modeDevice.Spec.NetworkConfigMode
os_image_urlstringThe URL is dynamically constructed once the device is created or updated. The URL will be based on the device hardware information URL format: base_url/dedicated_path/iso_version/architecture/os_type
ssh_configDevice.Spec.SSHConfig
attestation_configDevice.Spec.AttestationConfig
disable_device_discoveryboolDisables the daemon on the device for device auto discovery on the network. When it’s enabled, avahi-daemon is launched on the device which listens at UDP 5353. This daemon is useful to locate the device that acquires an IP address with DHCP.
logging_configDevice.Spec.LoggingConfig
proxy_configDevice.Spec.ProxyConfig
locationDevice.Spec.Location
usb_guardDevice.Spec.USBGuard
health_checksrepeated HealthCheckSpecCustom Health checks for device
disable_network_config_fallbackboolIf enabled, the default network configuration that was part of the initial disk image will never be used. This needs to be used with caution because clearing this flag would require access to device over console port or by connecting a Monitor to it.

Device.Status Message

NameTypeDescription
addressesrepeated Device.Status.AddressList of network addresses.
conditionsrepeated Device.Status.ConditionList of conditions of the Device.
network_config_stateDevice.Status.NetworkConfigState
proxy_config_statusDevice.Status.ProxyConfigStatus
device_infoDevice.Status.DeviceInfoDevice detailed information
attestation_statusrepeated PCR
normalized_addressDevice.Status.NormalizedAddressNormalized Address.
connection_statusDevice.Status.ConnectionStatus
connection_status_change_time.google.protobuf.TimestampLast change of connection_status

Device.PublicListingSpec Message

NameTypeDescription
enabledbool
field_mask.google.protobuf.FieldMask

Device.Spec.SSHConfig Message

SSHConfig defines the ssh configuration for the Device.

NameTypeDescription
disable_ssh_serverbool
disable_ssh_passwordbool
ssh_authorizedrepeated Device.Spec.SSHConfig.AuthKey
ip_allow_listrepeated string
ip_deny_listrepeated string
reject_period.google.protobuf.Duration
disable_ssh_authkeybool

Device.Spec.AttestationConfig Message

NameTypeDescription
attestation_expectedboolIf true, the droplet will try to attest itself.
attestation_domainstring (reference to AttestationDomain)Attestation domain for device attestation.

Device.Spec.LoggingConfig Message

NameTypeDescription
priorityint32Log priority as understood by systemd (0 - emergency, 1 - alert, 2 - critical, 3 - error, 4 - warning, 5 - notice, 6 - informational, 7 - debug). Journal logs with this priority and higher will be uploaded to the server.
unitsrepeated stringList of systemd unit names to monitor for logs, e.g. NetworkManager.service, docker.service. Leave empty to export all journald logs.
enable_journal_exportboolWhether the journald log exporter is enabled.
container_logging_configDevice.Spec.LoggingConfig.ContainerLoggingConfig

Device.Spec.ProxyConfig Message

NameTypeDescription
http_proxystring
https_proxystring
no_proxystring
proxy_interfacesrepeated stringBy default proxy is applicable for all interfaces configuring proxy_interfaces allows to restrict proxy setting to be used only with specific interfaces At present this is only used for Control Plane (for eg LTE fallback)

Device.Spec.Location Message

Device location of the device.

NameTypeDescription
addressstring
placementstring

Device.Spec.USBGuard Message

USB Guard. When enable is not set, USB guard service will not be started. When it is enabled, we can specify allowed device white list with WhiteList. Each device can be specified one of Device Name, Device ID or connected port number. We can specify multiple parameter for a device.

NameTypeDescription
enableboolEnable USB Guard service on the device.
white_listrepeated Device.Spec.USBGuard.WhiteListThis is array of white list of the USB devices.

Device.Spec.SSHConfig.AuthKey Message

NameTypeDescription
ssha_keystring
cert_authoritybool
commandstring
environmentstring
fromstring
no_agent_forwardingbool
no_port_forwardingbool
no_ptybool
no_user_rcbool
no_x11_forwardingbool
permitopenstring
principalsstring
tunnelstring
restrictbool

Device.Spec.LoggingConfig.ContainerLoggingConfig Message

Configuration to control how container log export is handled Only enable option is available now

NameTypeDescription
enable_container_log_exportboolEnable container log export. Default is disabled

Device.Spec.USBGuard.Port Message

USB match operator for “via-port”.

NameTypeDescription
equalsrepeated string
one_ofrepeated string

Device.Spec.USBGuard.Interface Message

USB match operator for “with-interface”.

NameTypeDescription
equalsrepeated string
one_ofrepeated string

Device.Spec.USBGuard.WhiteList Message

This is array of white list of the USB devices.

NameTypeDescription
device_namestringUSB device name to be allowed to connect.
device_idstringUSB device id to be allowed to connect.
via_portDevice.Spec.USBGuard.PortUSB port to be allowed to connect.
with_interfaceDevice.Spec.USBGuard.InterfaceUSB interface to be allowed to connect.
with_connect_typestringUSB connect type to be allowed to connect.

Device.Status.Address Message

Interface addresses of the Device.

NameTypeDescription
addressstringIPv4 or IPv6 address such as 203.0.113.5 (no suffix for subnet)
typestringAlways InternalIP

Device.Status.Condition Message

Condition holds status of each sub component or module of the device.

NameTypeDescription
messagestringThe message describes the status.
reasonstringThe reason for the status.
statusstringThe status name.
typestringType name of the status.
last_heart_beat_time.google.protobuf.TimestampWhen the status has been updated last time. Deprecated
last_transition_time.google.protobuf.TimestampWhen the status has tuned into the current value.

Device.Status.NetworkConfigState Message

NameTypeDescription
active_network_config_sourceDevice.Status.NetworkConfigState.NetworkConfigSource
desired_network_config_sourceDevice.Status.NetworkConfigState.NetworkConfigSource
desired_network_config_errorstring
default_netplan_configstring
active_netplan_configstring
desired_netplan_configstring

Device.Status.ProxyConfigStatus Message

NameTypeDescription
active_config_sourceDevice.Status.ProxyConfigStatus.ProxyConfigSource
desired_config_sourceDevice.Status.ProxyConfigStatus.ProxyConfigSource
proxy_config_errorstring
default_configDevice.Spec.ProxyConfig
active_configDevice.Spec.ProxyConfig
api_configDevice.Spec.ProxyConfig

Device.Status.DeviceInfo Message

Device Information

NameTypeDescription
architecturestringThe architecture of the CPU (and the software compilied for) (e.g. arm64)
hardwarestringThe platform hardware (e.g. raspberry, generic)
operating_systemstringBase OS name (e.g. Linux)
kernel_versionstringOS kernel version
os_imagestringOS base Image name
container_runtime_versionstringNot used
os_versionstringLiquid OS version currently used.
driverstringContainer driver name (e.g. /var/lib/droplet/compose)
hardware_informationDevice.Status.DeviceInfo.HardwareInformation
network_interfacesmap<string, Device.Status.DeviceInfo.NetworkInterface>
control_plane_interface_infoDevice.Status.DeviceInfo.ControlPlaneInterfaceInfo
managed_featuresDevice.Status.DeviceInfo.ManagedFeatures

Device.Status.NormalizedAddress Message

NameTypeDescription
postal_codestringPostal code
country_codestringCountry code example US, JP
continentstringContinent, e.g. North America, Asia
continent_idstring
countrystringCountry name example United States, Japan
country_idstring
admin_area1stringProbe Location Administrative Area level 1 name, e.g. California (state), Chiba (prefecture)
admin_area1_idstring
admin_area2stringProbe Location Administrative Area level 2 name, e.g. Santa Clara (county), Tateyama (town)
admin_area2_idstring
admin_area3stringProbe Location Administrative Area level 3 name, e.g. Sunnyvale (city)
admin_area3_idstring
admin_area4stringProbe Location Administrative Area level 4 name, e.g. Sunnyvale (city)
admin_area4_idstring
addressstringOriginal address.
coordinates.google.type.LatLngcoordinates
accuracydoublelocation accuracy in meters

Device.Status.DeviceInfo.HardwareInformation Message

NameTypeDescription
osDevice.Status.DeviceInfo.HardwareInformation.OS
biosDevice.Status.DeviceInfo.HardwareInformation.BIOS
systemDevice.Status.DeviceInfo.HardwareInformation.System
cpuDevice.Status.DeviceInfo.HardwareInformation.CPU
blockDevice.Status.DeviceInfo.HardwareInformation.Block
networkDevice.Status.DeviceInfo.HardwareInformation.Network
gpuDevice.Status.DeviceInfo.HardwareInformation.GPU
memory_infoDevice.Status.DeviceInfo.HardwareInformation.MemoryInfo
hailo_infoDevice.Status.DeviceInfo.HardwareInformation.HailoInfo
nvidia_infoDevice.Status.DeviceInfo.HardwareInformation.NvidiaInfo
modem_statusrepeated Device.Status.DeviceInfo.HardwareInformation.ModemStatus

Device.Status.DeviceInfo.NetworkInterface Message

Network Interface

NameTypeDescription
interface_namestring
ip_address_v4repeated string
external_ip_address_v4repeated string
ip_address_v6repeated string
external_ip_address_v6repeated string
as_infoDevice.Status.DeviceInfo.NetworkInterface.ASInfoAsinfo describes the ISP (ASN) details for the interface This is resolved automatically from the external_ip_address.
carrierDevice.Status.DeviceInfo.NetworkInterface.CarrierCarrier.

Device.Status.DeviceInfo.ControlPlaneInterfaceInfo Message

NameTypeDescription
active_control_plane_interfacestring
uses_proxybool
is_fallbackboolis_fallback would be true if droplet could not connect using the best default route and explicitly uses this interface to connect to api endpoint

Device.Status.DeviceInfo.ManagedFeatures Message

ManagedFeatures reports which management capabilities the droplet has enabled. These are static, derived from the droplet’s startup flags (–disable-os-management and the per-feature –disable-*-management flags), and only change when the droplet restarts with different flags. A true value means the droplet reconciles that feature against the Device spec; it does not reflect the live on/off state of the feature.

NameTypeDescription
osboolOS management (SSH, USB, Avahi, OS versioning). When false, the os/os_upgrade/ssh/usb/avahi features below are all unmanaged.
os_upgradeboolOS upgrade management.
sshboolSSH server/config management.
usbboolUSBGuard management.
avahiboolAvahi daemon management.
networkboolNetwork (netplan) management.
podsboolPod management.

Device.Status.DeviceInfo.HardwareInformation.Capability Message

NameTypeDescription
namestring
descriptionstring

Device.Status.DeviceInfo.HardwareInformation.OS Message

NameTypeDescription
operating_systemstring
kernel_versionstring
os_imagestring
container_runtime_versionstring

Device.Status.DeviceInfo.HardwareInformation.BIOS Message

TODO: Add capabilities and size

NameTypeDescription
vendorstring
bios_versionstring
release_datestring

Device.Status.DeviceInfo.HardwareInformation.System Message

NameTypeDescription
manufacturerstring
product_namestring
versionstring
serial_numberstring
configurationDevice.Status.DeviceInfo.HardwareInformation.System.Configuration

Device.Status.DeviceInfo.HardwareInformation.CPU Message

NameTypeDescription
processorsrepeated Device.Status.DeviceInfo.HardwareInformation.CPU.Processor

Device.Status.DeviceInfo.HardwareInformation.Block Message

NameTypeDescription
disksrepeated Device.Status.DeviceInfo.HardwareInformation.Block.Disk

Device.Status.DeviceInfo.HardwareInformation.Network Message

NameTypeDescription
nicsrepeated Device.Status.DeviceInfo.HardwareInformation.Network.NIC

Device.Status.DeviceInfo.HardwareInformation.GPU Message

NameTypeDescription
graphic_cardsrepeated Device.Status.DeviceInfo.HardwareInformation.GPU.GraphicCard

Device.Status.DeviceInfo.HardwareInformation.PCIDevice Message

Revisit: May be just device ??

NameTypeDescription
addressstring
vendorstring
productstring
namestring
subvendorstring

Device.Status.DeviceInfo.HardwareInformation.MemoryInfo Message

NameTypeDescription
descriptionstring
size_bytesint64
memory_banksrepeated Device.Status.DeviceInfo.HardwareInformation.MemoryInfo.MemoryBank

Device.Status.DeviceInfo.HardwareInformation.HailoInfo Message

NameTypeDescription
statusstring
cli_versionstring
modulesrepeated Device.Status.DeviceInfo.HardwareInformation.HailoInfo.HailoModuleInfo

Device.Status.DeviceInfo.HardwareInformation.NvidiaInfo Message

NameTypeDescription
statusstring
driver_versionstring
cuda_versionstring
gpusrepeated Device.Status.DeviceInfo.HardwareInformation.NvidiaInfo.GpuInfo

Device.Status.DeviceInfo.HardwareInformation.ModemStatus Message

NameTypeDescription
modemDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.Modem

Device.Status.DeviceInfo.HardwareInformation.System.Configuration Message

NameTypeDescription
chassisstring
uuidstring
sku_numberstring
familystring

Device.Status.DeviceInfo.HardwareInformation.CPU.Processor Message

NameTypeDescription
vendorstring
modelstring
capabilitiesrepeated Device.Status.DeviceInfo.HardwareInformation.Capability
num_threadsuint32s
num_coresuint32s
num_enabled_coresuint32s
namestring
serialstring
frequency_mhzint64
max_frequency_mhzint64
cache_inforepeated Device.Status.DeviceInfo.HardwareInformation.CPU.Processor.Cache
driverstring
latencyint64
clockint64

Device.Status.DeviceInfo.HardwareInformation.CPU.Processor.Cache Message

NameTypeDescription
typestring
size_bytesint64

Device.Status.DeviceInfo.HardwareInformation.Block.Disk Message

NameTypeDescription
namestring
size_bytesint64
drive_typestring
vendorstring
modelstring
serial_numberstring
wwnstring
partitionsrepeated Device.Status.DeviceInfo.HardwareInformation.Block.Disk.Partition

Device.Status.DeviceInfo.HardwareInformation.Block.Disk.Partition Message

NameTypeDescription
namestring
size_bytesint64
mount_pointstring
typestring

Device.Status.DeviceInfo.HardwareInformation.Network.NIC Message

NameTypeDescription
namestring
mac_addressstring
virtualbool
descriptionstring
product_namestring
vendorstring
subvendorstring
settingmap<string, string>

Device.Status.DeviceInfo.HardwareInformation.GPU.GraphicCard Message

NameTypeDescription
indexint64
deviceDevice.Status.DeviceInfo.HardwareInformation.PCIDevice

Device.Status.DeviceInfo.HardwareInformation.MemoryInfo.MemoryBank Message

NameTypeDescription
descriptionstring
productstring
vendorstring
serialstring
slotstring
size_bytesint64
frequency_hzint64
width_bitsint32

Device.Status.DeviceInfo.HardwareInformation.HailoInfo.HailoModuleInfo Message

NameTypeDescription
dev_idstring
control_proto_versionstring
firmware_versionstring
logger_versionstring
board_namestring
serial_numberstring
part_numberstring
product_namestring
neural_network_core_clock_ratestring

Device.Status.DeviceInfo.HardwareInformation.NvidiaInfo.GpuInfo Message

NameTypeDescription
idstring
product_namestring

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.RegistrationSettings Message

NameTypeDescription
drx_cyclestring
mico_modestring

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.FiveGNr Message

NameTypeDescription
registration_settingsDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.RegistrationSettings

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.Settings Message

NameTypeDescription
apnstring
ip_typestring
passwordstring
userstring

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.InitialBearer Message

NameTypeDescription
dbus_pathstring
settingsDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.Settings

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.Eps Message

NameTypeDescription
initial_bearerDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.InitialBearer
ue_mode_operationstring

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.ThreeGpp Message

NameTypeDescription
fiveg_nrDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.FiveGNr
enabled_locksrepeated string
epsDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.Eps
imeistring
operator_codestring
operator_namestring
packet_service_statestring
pcostring
registration_statestring

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.Cdma Message

NameTypeDescription
activation_statestring
cdma1x_registration_statestring
esnstring
evdo_registration_statestring
meidstring
nidstring
sidstring

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.SignalQuality Message

NameTypeDescription
recentstring
valuestring

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.Generic Message

NameTypeDescription
access_technologiesrepeated string
bearersrepeated string
carrier_configurationstring
carrier_configuration_revisionstring
current_bandsrepeated string
current_capabilitiesrepeated string
current_modesstring
devicestring
device_identifierstring
driversrepeated string
equipment_identifierstring
hardware_revisionstring
manufacturerstring
modelstring
own_numbersrepeated string
pluginstring
portsrepeated string
power_statestring
primary_portstring
primary_sim_slotstring
revisionstring
signal_qualityDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.SignalQuality
simstring
sim_slotsrepeated string
statestring
state_failed_reasonstring
supported_bandsrepeated string
supported_capabilitiesrepeated string
supported_ip_familiesrepeated string
supported_modesrepeated string
unlock_requiredstring
unlock_retriesrepeated string

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.SimStatus Message

NameTypeDescription
dbus_pathstring
activestring
eidstring
emergency_numbersrepeated string
esim_statusstring
gid1string
gid2string
iccidstring
imsistring
operator_codestring
operator_namestring
removabilitystring
sim_typestring

Device.Status.DeviceInfo.HardwareInformation.ModemStatus.Modem Message

NameTypeDescription
three_g_ppDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.ThreeGpp
cdmaDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.Cdma
dbus_pathstring
genericDevice.Status.DeviceInfo.HardwareInformation.ModemStatus.Generic
sim_statusmap<string, Device.Status.DeviceInfo.HardwareInformation.ModemStatus.SimStatus>

Device.Status.DeviceInfo.NetworkInterface.ASInfo Message

NameTypeDescription
asnstringAS Number string example AS7018
namestringAS Owner name example AT&T Services, Inc.
domainstringDomain name example att.com
routesrepeated stringRoutes exported from this ASN example 12.128.0.0/9
asn_typestringASN Owner type example isp(AT&T) / hosting(google)/ business (Amazon)

Device.Status.DeviceInfo.NetworkInterface.Carrier Message

NameTypeDescription
namestringMobile network carrier name example AT&T
mobile_country_codestringMobile country code example 214
mobile_network_codestringMobile network code example 7
location_area_codestringMobile location area code example 2862

GetDeviceRequest Message

A request message of the GetDevice method.

NameTypeDescription
namestring (name of Device)Name of ntt.devices.v1.Device
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetDevicesRequest Message

A request message of the BatchGetDevices method.

NameTypeDescription
namesrepeated string (name of Device)Names of Devices
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetDevicesResponse Message

A response message of the BatchGetDevices method.

NameTypeDescription
devicesrepeated Devicefound Devices
missingrepeated string (name of Device)list of not found Devices

ListDevicesRequest Message

A request message of the ListDevices method.

NameTypeDescription
parentstring (parent name of Device)Parent name of ntt.devices.v1.Device
page_sizeint32Requested page size. Server may return fewer Devices than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of Device)A token identifying a page of results the server should return. Typically, this is the value of ListDevicesResponse.next_page_token.
order_bystring (orderBy of Device)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of Device)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListDevicesResponse Message

A response message of the ListDevices method.

NameTypeDescription
devicesrepeated DeviceThe list of Devices
prev_page_tokenstring (cursor of Device)A token to retrieve previous page of results. Pass this value in the ListDevicesRequest.page_token.
next_page_tokenstring (cursor of Device)A token to retrieve next page of results. Pass this value in the ListDevicesRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total Devices across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchDeviceRequest Message

A request message of the WatchDevice method.

NameTypeDescription
namestring (name of Device)Name of ntt.devices.v1.Device
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchDeviceResponse Message

A response message of the WatchDevice method.

NameTypeDescription
changeDeviceChange

WatchDevicesRequest Message

A request message of the WatchDevices method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of Device)Parent name of ntt.devices.v1.Device
page_sizeint32Requested page size. Server may return fewer Devices than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of Device)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of Device)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of Device)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to Device that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to Device that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchDevicesResponse Message

A response message of the WatchDevices method.

NameTypeDescription
device_changesrepeated DeviceChangeChanges of Devices
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All Devices will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchDevicesResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (Devices will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchDevicesResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of Device)New token to retrieve previous page of results.
next_page_tokenstring (cursor of Device)New token to retrieve next page of results.

CreateDeviceRequest Message

A request message of the CreateDevice method.

NameTypeDescription
parentstring (parent name of Device)Parent name of ntt.devices.v1.Device
deviceDeviceDevice resource body
response_maskCreateDeviceRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateDeviceRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateDeviceRequest Message

A request message of the UpdateDevice method.

NameTypeDescription
deviceDeviceDevice resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateDeviceRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateDeviceRequest.ResponseMaskreduce message response size.

UpdateDeviceRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateDeviceConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateDeviceRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteDeviceRequest Message

A request message of the DeleteDevice method.

NameTypeDescription
namestring (name of Device)Name of ntt.devices.v1.Device
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

SearchDevicesRequest Message

A request message of the SearchDevices method.

NameTypeDescription
parentstring (parent name of Device)Parent name of ntt.devices.v1.Device
page_sizeint32Requested page size. Server may return fewer Devices than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of Device)A token identifying a page of results the server should return. Typically, this is the value of SearchDevicesResponse.next_page_token.
order_bystring (orderBy of Device)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of Device)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
phrasestringOptional search phrase used to further filter results.

SearchDevicesResponse Message

A response message of the SearchDevices method.

NameTypeDescription
devicesrepeated DeviceThe list of Devices
prev_page_tokenstring (cursor of Device)A token to retrieve previous page of results. Pass this value in the SearchDevicesRequest.page_token.
next_page_tokenstring (cursor of Device)A token to retrieve next page of results. Pass this value in the SearchDevicesRequest.page_token.
current_offsetint32Current offset from the first page (0 if no page tokens were given). Page index can be computed from offset and limit provided in a request
total_results_countint32Number of total Devices across all pages.

GetDedicatedEndpointsRequest Message

A request message of the [GetDedicatedEndpoints][ntt.devices.v1.GetDedicatedEndpoints]

NameTypeDescription
namestring (name of Device)

GetDedicatedEndpointsResponse Message

Response message for method [GetDedicatedEndpoints][ntt.devices.v1.GetDedicatedEndpoints]

NameTypeDescription
endpointsrepeated string

ProvisionServiceAccountToDeviceRequest Message

Request message for method [ProvisionServiceAccountToDevice][ntt.devices.v1.ProvisionServiceAccountToDevice]

NameTypeDescription
namestring (name of Device)Name of Device to provision service account. This method automatically generates a service account and a key for the device and assign the key to .Spec.ServiceAccount
external_pubkeystringexternal public key to use for service account for this device. If not present, a keypair will be generated by the server.

ProvisionServiceAccountToDeviceResponse Message

Response message for method [ProvisionServiceAccountToDevice][ntt.devices.v1.ProvisionServiceAccountToDevice]

NameTypeDescription
service_accountServiceAccountThe service account generated by the endpoint. Save the private key included.

RemoveServiceAccountFromDeviceRequest Message

Request message for method [RemoveServiceAccountFromDevice][ntt.devices.v1.RemoveServiceAccountFromDevice]

NameTypeDescription
namestring (name of Device)Name of the Device to remove its service account The service account and the key will be automatically deleted as well when they have been generated automatically by ProvisionServiceAccountToDevice action. Otherwise, the service account will be kept intact. The device will lost the access to the resources in the project.

RemoveServiceAccountFromDeviceResponse Message

Response message for method [RemoveServiceAccountFromDevice][ntt.devices.v1.RemoveServiceAccountFromDevice]

NameTypeDescription
nonenonenone

HeartbeatMsg Message

NameTypeDescription
namestring (name of Device)
registerHeartbeatMsg.Register
heartbeatHeartbeatMsg.Heartbeat

HeartbeatMsg.Register Message

NameTypeDescription
nonenonenone

HeartbeatMsg.Heartbeat Message

NameTypeDescription
nonenonenone

HeartbeatResponse Message

NameTypeDescription
desired_heartbeat_interval.google.protobuf.Duration

ReportDeviceMetricsRequest Message

A request message of the ReportDeviceMetrics method.

NameTypeDescription
namestring (name of Device)device_name abd region_id are required in first message for streaming
display_namestring
serial_numberstring
device_metricsDeviceMetrics

ReportDeviceMetricsResponse Message

NameTypeDescription
new_time_series_headersrepeated TimeSerieList of newly seen time series headers with unique binary key observed in corresponding ReportDeviceMetricsRequest.

ListPublicDevicesRequest Message

Request message for method [ListPublicDevices][ntt.devices.v1.ListPublicDevices]

NameTypeDescription
parentstring (parent name of Device)Parent name of ntt.devices.v1.Device
page_sizeint32Requested page size. Server may return fewer Devices than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of Device)A token identifying a page of results the server should return. Typically, this is the value of [ListDevicesResponse.next_page_token][ntt.devices.v1.ListDevicesResponse.next_page_token]
order_bystring (orderBy of Device)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of Device)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be requested on top of those defined by request field View.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

ListPublicDevicesResponse Message

Response message for method [ListPublicDevices][ntt.devices.v1.ListPublicDevices]

NameTypeDescription
devicesrepeated DeviceThe list of Devices
prev_page_tokenstring (cursor of Device)A token to retrieve previous page of results. Pass this value in the [ListDevicesRequest.page_token][ntt.devices.v1.ListDevicesRequest.page_token]
next_page_tokenstring (cursor of Device)A token to retrieve next page of results. Pass this value in the [ListDevicesRequest.page_token][ntt.devices.v1.ListDevicesRequest.page_token]

Device Enumerations

Here is the list of Device resource enumerations:

Device.Spec.NetworkConfigMode Enumeration

MERGE or REPLACE the api netplan_config with the baked in config in the device. REPLACE - The desired configuration must be input in full. The default config in disk will not be used. MERGE - Replaces level keys such as ethernet, modems, wifis etc that are defined in API config. Merge makes it easier to add new types of configuration - for example if the default configuration does not have wifis, it is easier to just add wifi config alone in API and use config mode merge. However, if the goal is to add to or replace a specific configuration in a section that already exists in the default configuration, then the API config should have the entire section and not just the changes for example if the default config on disk has eno1, eno2 under ethernet section and the goal is to replace the eno2 on disk, then the API configuration should specify both eno1 and eno2. This is because the merge mode still replaces whole sections that are defined in the API config

NameDescription
MERGE
REPLACE

Device.Status.ConnectionStatus Enumeration

NameDescription
CONNECTION_STATUS_UNSPECIFIED
CONNECTED
DISCONNECTED

Device.Status.NetworkConfigState.NetworkConfigSource Enumeration

NameDescription
UNKNOWN
DEFAULT_CONFIG
API_CONFIG
MERGED_DEFAULT_AND_API_CONFIG
PREVIOUS_MERGED_DEFAULT_AND_API_CONFIG
PREVIOUS_API_CONFIG

Device.Status.ProxyConfigStatus.ProxyConfigSource Enumeration

NameDescription
NO_CONFIG
DEFAULT_CONFIG
API_CONFIG

DeviceDistributionCounter Resource

DeviceDistributionCounter Resource

Name patterns:

  • projects/{project}/regions/{region}/deviceDistributionCounters/{device_distribution_counter}

Parent resources:

This section covers the methods and messages to interact with DeviceDistributionCounter resource.

DeviceDistributionCounter Methods

Here is the list of DeviceDistributionCounter resource methods:

GetDeviceDistributionCounter Method

GetDeviceDistributionCounter

rpc GetDeviceDistributionCounter(GetDeviceDistributionCounterRequest) returns (DeviceDistributionCounter)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceDistributionCounters.get

The equivalent REST API is:

GET /v1/{name=projects/*/regions/*/deviceDistributionCounters/*} 

BatchGetDeviceDistributionCounters Method

BatchGetDeviceDistributionCounters

rpc BatchGetDeviceDistributionCounters(BatchGetDeviceDistributionCountersRequest) returns (BatchGetDeviceDistributionCountersResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceDistributionCounters.batchGet

The equivalent REST API is:

GET /v1/deviceDistributionCounters:batchGet 

ListDeviceDistributionCounters Method

ListDeviceDistributionCounters

rpc ListDeviceDistributionCounters(ListDeviceDistributionCountersRequest) returns (ListDeviceDistributionCountersResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceDistributionCounters.list

The equivalent REST API is:

GET /v1/{parent=projects/*/regions/*}/deviceDistributionCounters 

WatchDeviceDistributionCounter Method

WatchDeviceDistributionCounter

rpc WatchDeviceDistributionCounter(WatchDeviceDistributionCounterRequest) returns (WatchDeviceDistributionCounterResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceDistributionCounters.watch

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/deviceDistributionCounters/*}:watch 

WatchDeviceDistributionCounters Method

WatchDeviceDistributionCounters

rpc WatchDeviceDistributionCounters(WatchDeviceDistributionCountersRequest) returns (WatchDeviceDistributionCountersResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceDistributionCounters.watch

The equivalent REST API is:

POST /v1/{parent=projects/*/regions/*}/deviceDistributionCounters:watch 

DeviceDistributionCounter Messages

Here is the list of DeviceDistributionCounter resource messages:

DeviceDistributionCounter Message

NameTypeDescription
namestring (name of DeviceDistributionCounter)Name of DeviceDistributionCounter When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
total_countint64
online_countint64

GetDeviceDistributionCounterRequest Message

A request message of the GetDeviceDistributionCounter method.

NameTypeDescription
namestring (name of DeviceDistributionCounter)Name of ntt.devices.v1.DeviceDistributionCounter
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetDeviceDistributionCountersRequest Message

A request message of the BatchGetDeviceDistributionCounters method.

NameTypeDescription
namesrepeated string (name of DeviceDistributionCounter)Names of DeviceDistributionCounters
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetDeviceDistributionCountersResponse Message

A response message of the BatchGetDeviceDistributionCounters method.

NameTypeDescription
device_distribution_countersrepeated DeviceDistributionCounterfound DeviceDistributionCounters
missingrepeated string (name of DeviceDistributionCounter)list of not found DeviceDistributionCounters

ListDeviceDistributionCountersRequest Message

A request message of the ListDeviceDistributionCounters method.

NameTypeDescription
parentstring (parent name of DeviceDistributionCounter)Parent name of ntt.devices.v1.DeviceDistributionCounter
page_sizeint32Requested page size. Server may return fewer DeviceDistributionCounters than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of DeviceDistributionCounter)A token identifying a page of results the server should return. Typically, this is the value of ListDeviceDistributionCountersResponse.next_page_token.
order_bystring (orderBy of DeviceDistributionCounter)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of DeviceDistributionCounter)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListDeviceDistributionCountersResponse Message

A response message of the ListDeviceDistributionCounters method.

NameTypeDescription
device_distribution_countersrepeated DeviceDistributionCounterThe list of DeviceDistributionCounters
prev_page_tokenstring (cursor of DeviceDistributionCounter)A token to retrieve previous page of results. Pass this value in the ListDeviceDistributionCountersRequest.page_token.
next_page_tokenstring (cursor of DeviceDistributionCounter)A token to retrieve next page of results. Pass this value in the ListDeviceDistributionCountersRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total DeviceDistributionCounters across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchDeviceDistributionCounterRequest Message

A request message of the WatchDeviceDistributionCounter method.

NameTypeDescription
namestring (name of DeviceDistributionCounter)Name of ntt.devices.v1.DeviceDistributionCounter
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchDeviceDistributionCounterResponse Message

A response message of the WatchDeviceDistributionCounter method.

NameTypeDescription
changeDeviceDistributionCounterChange

WatchDeviceDistributionCountersRequest Message

A request message of the WatchDeviceDistributionCounters method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of DeviceDistributionCounter)Parent name of ntt.devices.v1.DeviceDistributionCounter
page_sizeint32Requested page size. Server may return fewer DeviceDistributionCounters than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of DeviceDistributionCounter)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of DeviceDistributionCounter)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of DeviceDistributionCounter)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to DeviceDistributionCounter that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to DeviceDistributionCounter that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchDeviceDistributionCountersResponse Message

A response message of the WatchDeviceDistributionCounters method.

NameTypeDescription
device_distribution_counter_changesrepeated DeviceDistributionCounterChangeChanges of DeviceDistributionCounters
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All DeviceDistributionCounters will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchDeviceDistributionCountersResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (DeviceDistributionCounters will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchDeviceDistributionCountersResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of DeviceDistributionCounter)New token to retrieve previous page of results.
next_page_tokenstring (cursor of DeviceDistributionCounter)New token to retrieve next page of results.

DeviceHardware Resource

DeviceHardware Resource

Name patterns:

  • projects/{project}/regions/{region}/deviceHardwares/{device_hardware}

Parent resources:

This section covers the methods and messages to interact with DeviceHardware resource.

DeviceHardware Methods

Here is the list of DeviceHardware resource methods:

GetDeviceHardware Method

GetDeviceHardware

rpc GetDeviceHardware(GetDeviceHardwareRequest) returns (DeviceHardware)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwares.get

The equivalent REST API is:

GET /v1/{name=projects/*/regions/*/deviceHardwares/*} 

BatchGetDeviceHardwares Method

BatchGetDeviceHardwares

rpc BatchGetDeviceHardwares(BatchGetDeviceHardwaresRequest) returns (BatchGetDeviceHardwaresResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwares.batchGet

The equivalent REST API is:

GET /v1/deviceHardwares:batchGet 

ListDeviceHardwares Method

ListDeviceHardwares

rpc ListDeviceHardwares(ListDeviceHardwaresRequest) returns (ListDeviceHardwaresResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwares.list

The equivalent REST API is:

GET /v1/{parent=projects/*/regions/*}/deviceHardwares 

WatchDeviceHardware Method

WatchDeviceHardware

rpc WatchDeviceHardware(WatchDeviceHardwareRequest) returns (WatchDeviceHardwareResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwares.watch

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/deviceHardwares/*}:watch 

WatchDeviceHardwares Method

WatchDeviceHardwares

rpc WatchDeviceHardwares(WatchDeviceHardwaresRequest) returns (WatchDeviceHardwaresResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwares.watch

The equivalent REST API is:

POST /v1/{parent=projects/*/regions/*}/deviceHardwares:watch 

CreateDeviceHardware Method

CreateDeviceHardware

rpc CreateDeviceHardware(CreateDeviceHardwareRequest) returns (DeviceHardware)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwares.create

The equivalent REST API is:

POST /v1/{parent=projects/*/regions/*}/deviceHardwares (BODY: device_hardware)

UpdateDeviceHardware Method

UpdateDeviceHardware

rpc UpdateDeviceHardware(UpdateDeviceHardwareRequest) returns (DeviceHardware)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwares.update

The equivalent REST API is:

PUT /v1/{device_hardware.name=projects/*/regions/*/deviceHardwares/*} (BODY: device_hardware)

DeleteDeviceHardware Method

DeleteDeviceHardware

rpc DeleteDeviceHardware(DeleteDeviceHardwareRequest) returns (Empty)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwares.delete

The equivalent REST API is:

DELETE /v1/{name=projects/*/regions/*/deviceHardwares/*} 

Deregister Method

Deregister

rpc Deregister(DeregisterRequest) returns (DeregisterResponse)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwares.deregister

The equivalent REST API is:

POST /v1/{name=projects/*/regions/*/deviceHardwares/*}:deregister 

DeviceHardware Messages

Here is the list of DeviceHardware resource messages:

DeviceHardware Message

NameTypeDescription
namestring (name of DeviceHardware)Name of DeviceHardware When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9]
metadataMetaMetadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones).
display_namestring
serial_numberstring
manufacturerstring
product_namestringShould be in the format “productname (sku)”
mac_addressrepeated string
sim_iccidstringResult of activating sim card, which is specified by associated_sim_card field
imeistring
associated_provisioning_policy_namestring (reference to ProvisioningPolicy)
associated_devicestring (reference to Device)
associated_sim_cardstring (reference to SimCard)
statusDeviceHardware.Status

DeviceHardware.Status Message

NameTypeDescription
provisioning_stateDeviceHardware.Status.PROVISIONING_STATE

GetDeviceHardwareRequest Message

A request message of the GetDeviceHardware method.

NameTypeDescription
namestring (name of DeviceHardware)Name of ntt.devices.v1.DeviceHardware
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetDeviceHardwaresRequest Message

A request message of the BatchGetDeviceHardwares method.

NameTypeDescription
namesrepeated string (name of DeviceHardware)Names of DeviceHardwares
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

BatchGetDeviceHardwaresResponse Message

A response message of the BatchGetDeviceHardwares method.

NameTypeDescription
device_hardwaresrepeated DeviceHardwarefound DeviceHardwares
missingrepeated string (name of DeviceHardware)list of not found DeviceHardwares

ListDeviceHardwaresRequest Message

A request message of the ListDeviceHardwares method.

NameTypeDescription
parentstring (parent name of DeviceHardware)Parent name of ntt.devices.v1.DeviceHardware
page_sizeint32Requested page size. Server may return fewer DeviceHardwares than requested. If unspecified, server will pick an appropriate default.
page_tokenstring (cursor of DeviceHardware)A token identifying a page of results the server should return. Typically, this is the value of ListDeviceHardwaresResponse.next_page_token.
order_bystring (orderBy of DeviceHardware)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme”
filterstring (filter of DeviceHardware)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask
include_paging_infoboolIndicates if list response should contain total count and offset (fields current_offset and total_results_count).

ListDeviceHardwaresResponse Message

A response message of the ListDeviceHardwares method.

NameTypeDescription
device_hardwaresrepeated DeviceHardwareThe list of DeviceHardwares
prev_page_tokenstring (cursor of DeviceHardware)A token to retrieve previous page of results. Pass this value in the ListDeviceHardwaresRequest.page_token.
next_page_tokenstring (cursor of DeviceHardware)A token to retrieve next page of results. Pass this value in the ListDeviceHardwaresRequest.page_token.
current_offsetint32Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request.
total_results_countint32Number of total DeviceHardwares across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it.

WatchDeviceHardwareRequest Message

A request message of the WatchDeviceHardware method.

NameTypeDescription
namestring (name of DeviceHardware)Name of ntt.devices.v1.DeviceHardware
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask

WatchDeviceHardwareResponse Message

A response message of the WatchDeviceHardware method.

NameTypeDescription
changeDeviceHardwareChange

WatchDeviceHardwaresRequest Message

A request message of the WatchDeviceHardwares method.

NameTypeDescription
typeWatchTypeType of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant.
parentstring (parent name of DeviceHardware)Parent name of ntt.devices.v1.DeviceHardware
page_sizeint32Requested page size. Server may return fewer DeviceHardwares than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type.
page_tokenstring (cursor of DeviceHardware)A token identifying a page of results the server should return. Can be populated only for stateful watch type.
order_bystring (orderBy of DeviceHardware)Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type.
resume_tokenstringA token identifying watch resume point from previous session. Can be populated only for stateless watch type.
starting_time.google.protobuf.TimestampPoint in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection.
filterstring (filter of DeviceHardware)Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL
field_mask.google.protobuf.FieldMaskA list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to DeviceHardware that don’t affect any of masked fields won’t be sent back.
viewViewView defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to DeviceHardware that don’t affect any of masked fields won’t be sent back.
max_chunk_sizeint32Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default.

WatchDeviceHardwaresResponse Message

A response message of the WatchDeviceHardwares method.

NameTypeDescription
device_hardware_changesrepeated DeviceHardwareChangeChanges of DeviceHardwares
is_currentboolIf request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All DeviceHardwares will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0.
page_token_changeWatchDeviceHardwaresResponse.PageTokenChangeWhen present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk).
resume_tokenstringToken that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk).
snapshot_sizeint64Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags.
is_soft_resetboolIn case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size.
is_hard_resetboolIn case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (DeviceHardwares will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size.

WatchDeviceHardwaresResponse.PageTokenChange Message

NameTypeDescription
prev_page_tokenstring (cursor of DeviceHardware)New token to retrieve previous page of results.
next_page_tokenstring (cursor of DeviceHardware)New token to retrieve next page of results.

CreateDeviceHardwareRequest Message

A request message of the CreateDeviceHardware method.

NameTypeDescription
parentstring (parent name of DeviceHardware)Parent name of ntt.devices.v1.DeviceHardware
device_hardwareDeviceHardwareDeviceHardware resource body
response_maskCreateDeviceHardwareRequest.ResponseMaskOptional masking applied to response object to reduce message response size.

CreateDeviceHardwareRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields.

UpdateDeviceHardwareRequest Message

A request message of the UpdateDeviceHardware method.

NameTypeDescription
device_hardwareDeviceHardwareDeviceHardware resource body
update_mask.google.protobuf.FieldMaskFieldMask applied to request - change will be applied only for fields in the mask
casUpdateDeviceHardwareRequest.CASConditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned.
allow_missingboolIf set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update
response_maskUpdateDeviceHardwareRequest.ResponseMaskreduce message response size.

UpdateDeviceHardwareRequest.CAS Message

CAS - Compare and Swap. This object is used if user wants to make update conditional based upon previous resource version.

NameTypeDescription
conditional_stateDeviceHardwareConditional desired state of a resource before update.
field_mask.google.protobuf.FieldMaskField paths from conditional state of resource server should check and compare.

UpdateDeviceHardwareRequest.ResponseMask Message

ResponseMask allows client to reduce response message size.

NameTypeDescription
skip_entire_response_bodyboolIf this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set.
updated_fields_onlyboolInclude all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well.
body_mask.google.protobuf.FieldMaskIf this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored.

DeleteDeviceHardwareRequest Message

A request message of the DeleteDeviceHardware method.

NameTypeDescription
namestring (name of DeviceHardware)Name of ntt.devices.v1.DeviceHardware
allow_missingboolIf set to true, and the resource is not found, method will be successful and will not return NotFound error.

DeregisterRequest Message

Request message for method [Deregister][ntt.devices.v1.Deregister]

NameTypeDescription
namestring (name of DeviceHardware)Name of ntt.devices.v1.DeviceHardware

DeregisterResponse Message

Response message for method [Deregister][ntt.devices.v1.Deregister]

NameTypeDescription
nonenonenone

DeviceHardware Enumerations

Here is the list of DeviceHardware resource enumerations:

DeviceHardware.Status.PROVISIONING_STATE Enumeration

NameDescription
UNKNOWNHardware was deregistered, so device state cannot be tracked
SIM_ACTIVATINGThe SIM card is being activated.
CONNECTINGThe device would be connecting to ZTP as the attached SIM card was activated. If SIM card is not attached, this is the first status. If stuck at this value, provisioning could have failed.
NOT_PROVISIONEDDeprecated: This has been replaced by splitting into SIM_ACTIVATING and ZTP_CONNECTING
PROVISIONEDDevice passed attestation and service account is created Could be either provisioning policy scope for device scope account
REVOKEDFor device scope onboarding, the device was removed For provisioning policy based onboarding, the provisioning policy was removed

DeviceHardwareRegisterSession Resource

DeviceHardwareRegisterSession Resource

Name patterns:

  • projects/{project}/regions/{region}/deviceHardwareRegisterSessions/{device_hardware_register_session}

Parent resources:

This section covers the methods and messages to interact with DeviceHardwareRegisterSession resource.

DeviceHardwareRegisterSession Methods

Here is the list of DeviceHardwareRegisterSession resource methods:

GetDeviceHardwareRegisterSession Method

GetDeviceHardwareRegisterSession

rpc GetDeviceHardwareRegisterSession(GetDeviceHardwareRegisterSessionRequest) returns (DeviceHardwareRegisterSession)

with the following messages:

Required Permissions:

  • services/devices.edgelq.com/permissions/deviceHardwareRegisterSessions.get

The equivalent REST API is:

GET /v1/{name=projects/*/regions/*/deviceHardwareRegisterSessions/*} 

BatchGetDeviceHardwareRegisterSessions Method

BatchGetDeviceHardwareRegisterSessions

[...]
